<?php

/**
-------------------------------------------------------------------------
mediamallfactory - Media Mall Factory 4.2.2
-------------------------------------------------------------------------
 * @author thePHPfactory
 * @copyright Copyright (C) 2011 SKEPSIS Consult SRL. All Rights Reserved.
 * @license - http://www.gnu.org/licenses/gpl-2.0.html GNU/GPL
 * Websites: http://www.thePHPfactory.com
 * Technical Support: Forum - http://www.thePHPfactory.com/forum/
-------------------------------------------------------------------------
*/

defined('_JEXEC') or die;

class MediaMallFactoryBackendControllerOrder extends JControllerLegacy
{
    public function __construct($config = array())
    {
        parent::__construct($config);

        $this->registerTask('apply', 'save');
    }

    public function save()
    {
        JSession::checkToken() or jexit(JText::_('JINVALID_TOKEN'));

        $app = JFactory::getApplication();
        $data = JFactory::getApplication()->input->post->get('order', array(), 'array');
        $model = $this->getModel('Order');
        $id = JFactory::getApplication()->input->get->getInt('id', 0);

        $data['id'] = $id;

        if ($model->save($data)) {
            $msg = FactoryText::_('order_save_success');
        } else {
            $msg = FactoryText::_('order_save_error');

            foreach ($model->getErrors() as $error) {
                $app->enqueueMessage($error, 'error');
            }

            $id = $id ? '&id=' . $id : '';
            $this->setRedirect(FactoryRoute::view('order' . $id), $msg);

            return false;
        }

        $redirect = FactoryRoute::view('orders');

        if ('apply' == $this->getTask()) {
            $redirect = FactoryRoute::view('order&id=' . $model->getState('id'));
        }

        $this->setRedirect($redirect, $msg);

        return true;
    }

    public function cancel()
    {
        $this->setRedirect(FactoryRoute::view('orders'));
    }

    public function edit()
    {
        $cid = JFactory::getApplication()->input->post->get('cid', array(), 'array');
        $id = isset($cid[0]) ? $cid[0] : 0;

        $this->setRedirect(FactoryRoute::view('order&id=' . $id));
    }
}
