<?php

/**
-------------------------------------------------------------------------
mediamallfactory - Media Mall Factory 4.2.2
-------------------------------------------------------------------------
 * @author thePHPfactory
 * @copyright Copyright (C) 2011 SKEPSIS Consult SRL. All Rights Reserved.
 * @license - http://www.gnu.org/licenses/gpl-2.0.html GNU/GPL
 * Websites: http://www.thePHPfactory.com
 * Technical Support: Forum - http://www.thePHPfactory.com/forum/
-------------------------------------------------------------------------
*/

defined('_JEXEC') or die;

class FactoryHtml
{
    static $framework_loaded = false;

    public static function _($key)
    {
    }

    public static function script($file, $framework = true, $relative = false, $path_only = false, $detect_browser = true, $detect_debug = true)
    {
        if ($framework && !self::$framework_loaded) {
            self::$framework_loaded = true;

            JHtml::_('jQuery.framework');

            $document = JFactory::getDocument();
            $document->addScriptDeclaration('jQuery(document).ready(function ($) { $.ajaxPrefilter(function(options, originalOptions, jqXHR) { options.url = "' . JURI::root() . '" + options.url; }); });');
        }

        $file = self::parsePath($file);

        JHtml::script($file, $framework, $relative, $path_only, $detect_browser, $detect_debug);
    }

    public static function stylesheet($file, $attribs = array(), $relative = false, $path_only = false, $detect_browser = true, $detect_debug = true)
    {
        $file = self::parsePath($file, 'css');

        JHtml::stylesheet($file, $attribs, $relative, $path_only, $detect_browser, $detect_debug);
    }

    protected static function parsePath($file, $type = 'js')
    {
        $path = array();
        $parts = explode('/', $file);

        $path[] = 'media';
        $path[] = FactoryApplication::getInstance()->getOption();
        $path[] = 'assets';

        if (isset($parts[0])) {
            if ('admin' === $parts[0]) {
                $path[] = 'backend';
                unset($parts[0]);
                $parts = array_values($parts);
            } else {
                $path[] = 'frontend';
            }
        }

        $path[] = $type;

        $count = count($parts);
        foreach ($parts as $i => $part) {
            if ($i + 1 == $count) {
                $path[] = $part . '.' . $type;
            } else {
                $path[] = $part;
            }
        }

        return implode('/', $path);
    }
}
