<?php

/**
-------------------------------------------------------------------------
mediamallfactory - Media Mall Factory 4.2.2
-------------------------------------------------------------------------
 * @author thePHPfactory
 * @copyright Copyright (C) 2011 SKEPSIS Consult SRL. All Rights Reserved.
 * @license - http://www.gnu.org/licenses/gpl-2.0.html GNU/GPL
 * Websites: http://www.thePHPfactory.com
 * Technical Support: Forum - http://www.thePHPfactory.com/forum/
-------------------------------------------------------------------------
*/

defined('_JEXEC') or die;

jimport('joomla.application.component.model');

class MediaMallFactoryFrontendModelEditProfile extends FactoryModel
{
    protected $form_name = 'profile';

    public function getForm($loadData = true)
    {
        // Get the form.
        $form = FactoryForm::getInstance($this->form_name, $this->form_name, array('control' => $this->form_name));

        if ($loadData) {
            $data = $this->loadFormData();
        } else {
            $data = array();
        }

        $authors = FactoryApplication::getInstance()->getParam('authors.global.author', array());
        if (!array_intersect(JFactory::getUser()->groups, $authors)) {
            $form->removeFieldset('author');
        }

        $form->bind($data);

        return $form;
    }

    public function save($data)
    {
        // Initialise variables.
        $form = $this->getForm(false);
        $data = $form->filter($data);
        $return = $form->validate($data);

        // Check if form is valid.
        if (!$return) {
            foreach ($form->getErrors() as $message) {
                $this->setError(JText::_($message));
            }

            return false;
        }

        // Save the media.
        $table = JTable::getInstance('Profile', 'MediaMallFactoryTable');

        if (!$table->save($data)) {
            $this->setError($table->getError());
            return false;
        }

        return true;
    }

    protected function loadFormData()
    {
        // Check the session for previously entered form data.
        $name = $this->getName();
        $option = FactoryApplication::getInstance()->getOption();
        $context = $option . '.edit.' . $name . '.data';

        $data = JFactory::getApplication()->getUserState($context, array());
        JFactory::getApplication()->setUserState($context, array());

        if (!$data) {
            $data = $this->getItem();
            $data->params = $data->params->toArray();
        }

        return $data;
    }

    public function getItem()
    {
        static $items = array();

        $user_id = JFactory::getUser()->id;

        if (!isset($items[$user_id])) {
            $table = JTable::getInstance('Profile', 'MediaMallFactoryTable');
            $table->load($user_id);

            // Create profile if it doesn't exist.
            if (!$table->user_id) {
                $table = $table->createProfile($user_id);
            }

            $items[$user_id] = $table;
        }

        return $items[$user_id];
    }
}
